    
/*function supports_json() {
    try {
        return 'JSON' in window && window['JSON'] !== null;
    } catch (e) {
        return false;
    }
}*/
//remove from storage
/*function clearStorage() {
    window['localStorage'].clear();
    BwtApp.saveStorage();
}*/


BwtApp.hasNetworkConnection = function() {
    
    var networkState = navigator.connection.type;
    
    var states = {};
    states[Connection.UNKNOWN]  = 'Unknown connection';
    states[Connection.ETHERNET] = 'Ethernet connection';
    states[Connection.WIFI]     = 'WiFi connection';
    states[Connection.CELL_2G]  = 'Cell 2G connection';
    states[Connection.CELL_3G]  = 'Cell 3G connection';
    states[Connection.CELL_4G]  = 'Cell 4G connection';
    states[Connection.CELL]     = 'Cell generic connection';
    states[Connection.NONE]     = 'No network connection';         
    
    if(states[networkState] === 'No network connection'){
        return false;
        
    }else{
        return true;
    }
    
};


BwtApp.addToStorage = function(id, label) {
    //window['localStorage'].setItem(id, JSON.stringify(label));
    window.localStorage.setItem(id, JSON.stringify(label));
    BwtApp.saveStorage();
};

BwtApp.removeFromStorage = function(id, label) {
    //window['localStorage'].removeItem(id);
    window.localStorage.removeItem(id);
    BwtApp.saveStorage();
};

BwtApp.hasInStorage = function(id) {
    //return JSON.parse((window['localStorage'].getItem(id)));
    return JSON.parse((window.localStorage.getItem(id)));
};

BwtApp.saveStorage = function() {
    var data = BwtApp.getStorage();
    localStorage = window.JSON.stringify(data);
};

BwtApp.getStorage = function() {
    var data;
    //var current = window['localStorage'];
    var current = window.localStorage;
    if (typeof current != "undefined") {data = current;}
    return data;
};

BwtApp.getItemFromStorage = function(item) {
    return localStorage.getItem(item);
};


BwtApp.getColor = function(waitTime) {
    $green = "rgb(231, 242, 226)";
    $yellow = "rgb(255, 241, 193)";
    $red = "rgb(246, 229, 229)";
    if (waitTime > 60)
        return $red;
    else if (waitTime > 30)
        return $yellow;
    else
        return $green;
};

BwtApp.getSideColor = function(waitTime) {
    $greenside = "#339900";
    $yellowside = "#ffa100";
    $redside = "#cc0033";
    if (waitTime > 60)
        return $redside;
    else if (waitTime > 30)
        return $yellowside;
    else
        return $greenside;
};

BwtApp.getEl = function(id) {
    return document.getElementById(id);
};


BwtApp.uri = "https://bwt.cbp.gov/api/waittimes";
//BwtApp.info;
//BwtApp.refreshRateValue;
//BwtApp.startupPage;
//BwtApp.intervalId;
//BwtApp.lastRefreshDttm;
//BwtApp.statusRefreshIntervalId;

BwtApp.lastRefreshFunc = function() {
    //this function displays the last refreshed date time on details page.
    var newDate = new Date();
    
    if(BwtApp.lastRefreshDttm){
    
        var diffMin = BwtApp.getDiffBetweenDttm(BwtApp.lastRefreshDttm, newDate);
        
        if (diffMin < 2){
            document.getElementById("lastRefreshInfo").innerHTML = "Refreshed Just Now";
        }
        else if (diffMin >= 2 && diffMin <=5){
            document.getElementById("lastRefreshInfo").innerHTML = "Refreshed " + diffMin + " minutes ago";
        }
        else{
        
            //check if the 2 dates are same if same display just the time
            //otherwise display the date and time.
            if(BwtApp.lastRefreshDttm.toLocaleDateString() === newDate.toLocaleDateString())
            {
                document.getElementById("lastRefreshInfo").innerHTML = "Refreshed at " + BwtApp.lastRefreshDttm.toLocaleTimeString();
            }
            else{
                document.getElementById("lastRefreshInfo").innerHTML = "Refreshed " + BwtApp.lastRefreshDttm.toLocaleDateString() + " " + BwtApp.lastRefreshDttm.toLocaleTimeString();
            }
        
        }
    }//end if there is a value for BwtApp.lastRefreshDttm
    else{
        document.getElementById("lastRefreshInfo").innerHTML = "Could not connect";
    }
};

BwtApp.getDiffBetweenDttm = function( date1, date2 ) {
    
    var one_day=1000*60;
    // Convert both dates to milliseconds
    var date1_ms = date1.getTime();
    var date2_ms = date2.getTime();
    // Calculate the difference in milliseconds
    var difference_ms = date2_ms - date1_ms;
    // Convert back to days and return
    return Math.round(difference_ms/one_day);
};


//************   get data from BWT webservice   ***************
BwtApp.getBWTData = function (cb) {
    $.ajax({
           beforeSend: showPageLoadingMsg(), //Show spinner
           type: 'GET',
           url: BwtApp.uri,
           crossDomain: true,
           contentType: "application/json; charset=utf-8",
           dataType: "jsonp",
           success: function (msg) {
           //console.log("got data");
           BwtApp.info = msg;
           BwtApp.lastRefreshDttm = new Date();
           
           BwtApp.lastRefreshFunc();
           //this checks if a function is passed into the function.
           if (cb) cb();
              $.mobile.loading('hide');
           },
           error: function (xhr, status) {
              //console.log("retrying");
           setTimeout ( function(){ BwtApp.getBWTData(cb); }, 5000 );
           },
           async: true,
           cache: false
           });
};

function showPageLoadingMsg() {
    var html = "<span style='text-align: center; font-size:.75em;' class='ui-bar ui-shadow ui-overlay-d ui-corner-all'><img src='Content/images/spinLoader.gif'><br/>Trying to connect...</span>";
    $.mobile.loading( "show", {
                     text: "Trying to connect...",
                     textVisible: true,
                     theme: "a",
                     textonly: false,
                     html: html
                     });
}
function hidePageLoadingMsg() {
    $.mobile.loading('hide');
}

//******************   UPDATE DETAILS PAGE    *************************
BwtApp.updateDetailsPage = function(cb) {
    
    //the code below finds the active page
    var activePage = $.mobile.activePage[0].id;
   
    if (activePage === "details-page") {
        var detailspageinfo = $("#details-page").data("info");
        var thisInfo;
        //******************** the below code gets port info from "info" json object ******************
          jQuery.map(BwtApp.info, function (obj) {
             if (obj.port_number === detailspageinfo.port_number){
             thisInfo = obj;
             console.log("port number same");
             $("#details-page").data("info", thisInfo);
             $.mobile.changePage(
                                 "#details-page",
                                 {
                                 allowSamePageTransition: true,
                                 transition: 'none',
                                 showLoadMsg: false
                                 });
             if($.isFunction(cb)) cb();
            }
           });
        //*******************  end code gets port info from "info" json object  ************************
    }
};


//*******************   REFRESH HANDLER   *********************

BwtApp.refresh_handler = function(refreshCallback) {
    function refresh() {
        BwtApp.getBWTData(function () {
            BwtApp.updateDetailsPage(function () {
                 BwtApp.lastRefreshFunc();
                                     BwtApp.statusRefreshIntervalId = setInterval(function(){BwtApp.lastRefreshFunc();}, 60000);
            });
        });
    }
    
    BwtApp.refreshRateValue = BwtApp.getItemFromStorage("refreshRate");
    
    if (isNaN(BwtApp.refreshRateValue)) {
        BwtApp.refreshRateValue = BwtApp.refreshRateValue.replace('"', "");
    }
    
    BwtApp.intervalId = setInterval(function(){refresh();}, parseInt(BwtApp.refreshRateValue) * 60000);    //60000 = 1 min, 1 sec=1000 milliseconds
    
    if($.isFunction(refreshCallback)) refreshCallback();
};
//*******************   STORAGE INITIALIZE   *********************
BwtApp.initializeLocalStorageValues = function(){
    
    if (BwtApp.hasInStorage("refreshRate")) {
        BwtApp.refreshRateValue = BwtApp.getItemFromStorage("refreshRate");
    }
    else {
        BwtApp.refreshRateValue = 60;
        BwtApp.addToStorage("refreshRate", BwtApp.refreshRateValue);
    }
    
    if (BwtApp.hasInStorage("startPg")) {
        BwtApp.startupPage = BwtApp.getItemFromStorage("startPg");
    }
    else {
        BwtApp.startupPage = "Home";
        BwtApp.addToStorage("startPg", BwtApp.startupPage);
    }
};



//*************   SHOWCONFIRM   ************************
BwtApp.showConfirm = function () {
    $("#confirmbox").on("click", ".btnConfirmYes", function (e) {
        e.preventDefault();
        BwtApp.addToStorage("acceptedDisclaimer", "yes");
                        
        BwtApp.initializeLocalStorageValues();
           
           if(BwtApp.hasNetworkConnection()){
               BwtApp.getBWTData();
           }
           else{
             navigator.notification.alert("Network connection not available" , function(){
                    BwtApp.getBWTData();
             }, "BWT", "OK");
           }
           //BwtApp.downloadQa();
           BwtApp.refresh_handler();

        $.mobile.changePage("#Home", { transition: "slide" });
    });
};



//**************   RESUME   ***************
BwtApp.onResume = function(){
    setTimeout(function(){
       var activePage = $.mobile.activePage[0].id;
       if (activePage === "confirmbox") {
         BwtApp.showConfirm();
       }
       else{
         BwtApp.getBWTData(function(){
             BwtApp.lastRefreshFunc();
                           BwtApp.statusRefreshIntervalId = setInterval(function(){BwtApp.lastRefreshFunc();}, 60000);
             BwtApp.refresh_handler();
             
             if (activePage === "nearestPorts") {
                 BwtApp.getLocation();
             }//end if nearestports page
         });
       }
               
    },0); //end setTimeout
};


//*************   PAUSE   ****************
BwtApp.onPause = function(){
    if(BwtApp.intervalId){
        clearInterval(BwtApp.intervalId);
    }
    if(BwtApp.statusRefreshIntervalId){
        clearInterval(BwtApp.statusRefreshIntervalId);
    }
};
//******* VV IMP this was added for android. Test if it has any effect on ios
BwtApp.onBackKeyDown = function(){
    if($.mobile.activePage.is('#Home')){
        navigator.app.exitApp();
    }else{
        navigator.app.backHistory();
    }    
};

//**************  onDeviceReady  *****************************
function onDeviceReady(){
    
    document.addEventListener("resume", BwtApp.onResume, false);
    document.addEventListener("pause", BwtApp.onPause, false);
    document.addEventListener("backbutton", BwtApp.onBackKeyDown, false);
    
    
    if (BwtApp.hasInStorage("acceptedDisclaimer")) {
        BwtApp.initializeLocalStorageValues();
        var re = /"/g;
        //the code below checks if network connection is available then does the work
        if(BwtApp.hasNetworkConnection()){
            BwtApp.getBWTData(function () {
              window.location.hash = BwtApp.startupPage.replace(re, "");
              $.mobile.initializePage();
              //hide spalsh screen
              navigator.splashscreen.hide();
                              BwtApp.statusRefreshIntervalId = setInterval(function(){BwtApp.lastRefreshFunc();}, 60000);
                              
            });
        }
        else{
            navigator.notification.alert("Network connection not available" , function(){
             var re = /"/g;
             window.location.hash = BwtApp.startupPage.replace(re, "");
             $.mobile.initializePage();
             BwtApp.getBWTData(function () {
                   var activePage = $.mobile.activePage[0].id;
                               BwtApp.statusRefreshIntervalId = setInterval(function(){BwtApp.lastRefreshFunc();}, 60000);
                   $.mobile.changePage(
                       "#" + activePage,
                       {
                       allowSamePageTransition: true,
                       transition: 'none',
                       showLoadMsg: false
                       });
                });
              //hide spalsh screen
              navigator.splashscreen.hide();
             
             }, "BWT", "OK");
        }//end check network connection available.
        
        
            //  BwtApp.downloadQa();
            BwtApp.refresh_handler();
    }
    else {
        //Not Found in storage        
        $.mobile.changePage("#confirmbox");
        $.mobile.initializePage();
        //hide spalsh screen
        navigator.splashscreen.hide();
        BwtApp.showConfirm();
    }
    
    //***********************PULL TO REFRESH************************
    var container_el = BwtApp.getEl('container');
    var pullrefresh_el = BwtApp.getEl('pullrefresh');
    var pullrefresh_icon_el = BwtApp.getEl('pullrefresh-icon');
    
    var refreshPull = new PullToRefresh(container_el, pullrefresh_el, pullrefresh_icon_el);
    
    refreshPull.handler = function () {
        $("#lastRefreshInfo").innerHTML = "Connecting...";
        var self = this;
        
        if(BwtApp.hasNetworkConnection()){
            BwtApp.getBWTData(function () {
            $("#lastRefreshInfo").innerHTML = "Getting data...";
               BwtApp.updateDetailsPage(function () {
                    BwtApp.lastRefreshFunc();
                                        BwtApp.statusRefreshIntervalId = setInterval(function(){BwtApp.lastRefreshFunc();}, 60000);
                });
             self.slideUp();
             });
        }//end if has network connection
        else{
            self.slideUp();
            navigator.notification.alert("Network connection not available" , function(){
                 $("#lastRefreshInfo").innerHTML = "Could not connect";
             }, "BWT", "OK");
        }
       
    };//end refresh pull handler
    //***********************END PULL TO REFRESH************************
    
    
    $("a.externalLink").unbind('click').click(function(e) {
         var elem = $(this);
         var url = elem.attr('href');
         if (url.indexOf('http://') !== -1 ) {
         //if (url.indexOf('http') !== -1) {
           e.preventDefault();
          if(device.platform == 'Android'){
            window.open(url, '_system');
            return false;
          }
          else{
          //alert("ios");
          //device is ios
          var ref = window.open(url, '_blank', 'location=no,toolbar=yes,toolbarposition=top,enableviewportscale=yes,clearsessioncache=yes,clearcache=yes');
                                              
          ref.addEventListener('loaderror', function(event) {
                               //alert(event.code);
                               if(event.code == -999)return;
                               navigator.notification.alert(event.message, null, "BWT", "OK");
                               });
          ref.addEventListener("loadstop", function(event) {
                               ref=null;
                               });
          
          }//end else
        }
     });   
    
}

//added new 11/24/2014
$(document).on('pagebeforechange', function(e, data){
               
       var to = data.toPage;
       
       if ((typeof to  === 'string') && data.toPage.indexOf('index.html') >= 0){
       //alert("index of: " + data.toPage.indexOf('index.html'));
       var u = $.mobile.path.parseUrl(to);
       to = u.hash || '#' + u.pathname.substring(1);
       var toDestination = "";
       toDestination = u.hash;
       //alert("to: " + to);
       //alert("u.hash: " + u.hash);
       //if (to === '#confirmbox') {
       if(toDestination === ""){
       //alert('Can not transition the page #confirmbox!');
           e.preventDefault();
           e.stopPropagation();
           history.go(1);
           
           // remove active status on a button, if transition was triggered with a button
           $.mobile.activePage.find('.ui-btn-active').removeClass('ui-btn-active ui-shadow').css({'box-shadow':'0 0 0 #3388CC'});
           } 
       }
              
});
//added new end

$(document).on("pageinit", "#confirmbox", function () {
               
    $(".btnConfirmYes").hide();
               
    $.getScript('Scripts/disclaimer.js', function () {
        var text = disclaimerText1 + "<p/>" + disclaimerPrompt + "<br/>" + disclaimerText2;        
        $("#confirmMsg").html(text);
        $(".btnConfirmYes").show();
        $("a.externalLink").unbind('click').click(function(e) {
             var elem = $(this);
             var url = elem.attr('href');
             if (url.indexOf('http://') !== -1) {
                 e.preventDefault();
                 //window.open(url, '_system');
                 //return false;
                  if(device.platform == 'Android'){
                  window.open(url, '_system');
                  return false;
                  }
                  else{
                  //device is ios
                  var ref = window.open(url, '_blank', 'location=no,toolbar=yes,toolbarposition=top,enableviewportscale=yes,clearsessioncache=yes,clearcache=yes');
                  ref.addEventListener('loaderror', function(event) {
                                       if(event.code == -999)return;
                                       navigator.notification.alert(event.message, null, "BWT", "OK");
                                       });
                  ref.addEventListener("loadstop", function(event) {
                                       ref=null;
                                       });
                  
                  }//end else
             }
        });
    });
               
});

$(document).on("pageinit", "#disclaimer", function () {
    $.getScript('Scripts/disclaimer.js', function () {
        var text = disclaimerText1 + "<br/><br/>" + disclaimerText2;
        $("#disclaimerMsg").html(text);
                
        $("a.externalLink").unbind('click').click(function(e) {
              var elem = $(this);
              var url = elem.attr('href');
              if (url.indexOf('http://') !== -1) {
               e.preventDefault();
               //window.open(url, '_system');
               //return false;
                                                  
              if(device.platform=='Android'){
              window.open(url, '_system');
              return false;
              }
              else{
              //device is ios
              var ref = window.open(url, '_blank', 'location=no,toolbar=yes,toolbarposition=top,enableviewportscale=yes,clearsessioncache=yes,clearcache=yes');
                                                  
              ref.addEventListener('loaderror', function(event) {
                                   if(event.code == -999)return;
                                    navigator.notification.alert(event.message, null, "BWT", "OK");
                                   });
              ref.addEventListener("loadstop", function(event) {
                                   ref=null;
                                   });
              
              }//end else
                                                  
                                                  
              }
        });
    });
}); 


//Inappbrowser for FAQ
$(document).on("click", ".faq", function () {
               if(device.platform=='Android'){
                   window.open('http://bwt.cbp.gov/mfaq.html', '_system');
                   return false;
               }
               else{
               
                   var ref = window.open('http://bwt.cbp.gov/mfaq.html', '_blank', 'location=no,toolbar=yes,toolbarposition=top,enableviewportscale=yes,clearsessioncache=yes,clearcache=yes');
                   ref.addEventListener('loaderror', function(event) {
                                        if(event.code == -999)return;
                                        navigator.notification.alert(event.message, null, "BWT", "OK");
                                        });
                   ref.addEventListener("loadstop", function(event) {
                                        ref=null;
                                        });
               }
               
               });

//Inappbrowser for Resources
$(document).on("click", ".resources", function () {
               if(device.platform=='Android'){
                   window.open('http://bwt.cbp.gov/mresources.html', '_system');
                   return false;
               }
               else{
               
                   var ref = window.open('http://bwt.cbp.gov/mresources.html', '_blank', 'location=no,toolbar=yes,toolbarposition=top,enableviewportscale=yes,clearsessioncache=yes,clearcache=yes');
                   
                   ref.addEventListener('loaderror', function(event) {
                                        if(event.code == -999)return;
                                        navigator.notification.alert(event.message, null, "BWT", "OK");
                                        });
                   ref.addEventListener("loadstop", function(event) {
                                        ref=null;
                                        });
               }
        
});

//*****************************  START NORTH PAGE    *************************************************************************
$(document).on("pagebeforeshow", "#northPage", function () {

  if(BwtApp.info){
    var updatedDate = "";
    var northli = "";
    $("#north-list").empty();
    $.each(BwtApp.info, function (i, name) {
        //add the <li> to "li" variable
        updatedDate = name.date + " " + name.time;
        if(name.port_status.toLowerCase() === "open"){
           $portStatusDisplay = "<span style='color: #339900; font-weight:lighter;'> is " + name.port_status.toLowerCase() + "</span>";
        }
        else if(name.port_status.toLowerCase() === "closed"){
           $portStatusDisplay = "<span style='color: #cc0033; font-weight:lighter;'> is " + name.port_status.toLowerCase() + "</span>";
        }
        if (name.border == 'Canadian Border') {
            northli += '<li><a href="#" id="' + name.port_number + '" class="info-go">' + name.port_name + ' - ' + $portStatusDisplay + '<p>' + name.crossing_name + '</p></a></li>';
        }
    });
    
    //append list to ul
    $("#north-list").append(northli).promise().done(function () {
        $('#north-list').unbind('click');
        $(this).on("click", ".info-go", function (e) {
           e.preventDefault();
           var thisId = this.id;
           var thisInfo;
           BwtApp.getBWTData(function () {
             //******************** the below code gets port info from "info" json object ******************
             jQuery.map(BwtApp.info, function (obj) {
                        if (obj.port_number === thisId){
                          thisInfo = obj;
                        }
              });
             //*******************  end code gets port info from "info" json object  ************************
             $("#details-page").data("info", thisInfo);
             $.mobile.changePage("#details-page", { transition: "fade" });
                             
           });//end get bwt data
        });
        //refresh list to enhance its styling.
        $(this).listview("refresh");
    });
}//end if BwtApp.info
else{
               //alert("data not available");
}
    
});
//*****************************  END NORTH PAGE    ****************************************************************************


//*****************************  START SOUTH PAGE    ****************************************************************************
$(document).on("pagebeforeshow", "#south-page", function () {
    //set up string for adding <li/>
    //var southli = "";
    //var updatedDate = "";
    $portStatusDisplay="";
    
    if(BwtApp.info){
        var southli = "";
        var updatedDate = "";
                   
        $portStatusDisplay="";
        $("#south-list").empty();
                   
        //container for $li to be added
        $.each(BwtApp.info, function (i, name) {
            //add the <li> to "li" variable
            updatedDate = name.date + " " + name.time;
            if(name.port_status.toLowerCase() === "open"){
               $portStatusDisplay = "<span style='color: #339900; font-weight:lighter;'> is " + name.port_status.toLowerCase() + "</span>";
            }
            else if(name.port_status.toLowerCase() === "closed"){
               $portStatusDisplay = "<span style='color: #cc0033; font-weight:lighter;'> is " + name.port_status.toLowerCase() + "</span>";
            }
            if (name.border == 'Mexican Border') {
                southli += '<li><a href="#" id="' + name.port_number + '" class="info-go">' + name.port_name + ' - ' + $portStatusDisplay + '<p>' + name.crossing_name + '</p></a></li>';
            }
        });
    //append list to ul
    $("#south-list").append(southli).promise().done(function () {
        $('#south-list').unbind('click');
        $(this).on("click", ".info-go", function (e) {
            e.preventDefault();
            var thisId = this.id;
            var thisInfo;
            BwtApp.getBWTData(function () {
             //******************** the below code gets port info from "info" json object ******************
             jQuery.map(BwtApp.info, function (obj) {
                        if (obj.port_number === thisId){
                           thisInfo = obj;
                        }
              });
             //*******************  end code gets port info from "info" json object  ************************
             
             $("#details-page").data("info", thisInfo);
             $.mobile.changePage("#details-page", { transition: "fade" });
             
             });//end get bwt data
        });

        //refresh list to enhance its styling.
        $(this).listview("refresh");
    });
  }//end if BwtApp.info
  else{
    //alert("data not available");
  }
});
//*****************************  END SOUTH PAGE   *****************************************************


/****************************  START FAVORITES PAGE  ***************************************************/

$(document).on("pagebeforeshow", "#fav-page", function () {
       if(BwtApp.info){
         BwtApp.createFavoritesList();
       }
       else{
           //alert("data not available");
       }
});
//function BwtApp.createFavoritesList
BwtApp.createFavoritesList = function() {
    
    var favli = "";
    $portStatusDisplay="";
    
    $("#fav-list").empty();
    $("#favNote").empty();
    
    $.each(BwtApp.info, function (i, name) {
           if(name.port_status.toLowerCase() === "open"){
                $portStatusDisplay = "<span style='color: #339900; font-weight:lighter;'> is " + name.port_status.toLowerCase() + "</span>";
           }
           else if(name.port_status.toLowerCase() === "closed"){
                $portStatusDisplay = "<span style='color: #cc0033; font-weight:lighter;'> is " + name.port_status.toLowerCase() + "</span>";
           }
           
        if (BwtApp.hasInStorage(name.port_number)) {
            favli += '<li><a href="#" id="' + name.port_number + '" class="info-go">' + name.port_name + ' - ' + $portStatusDisplay + '<p>' + name.crossing_name + '</p></a></li>';
        }
        
    });
    
    if(favli === ""){
        $("#favNote").text("You have not added any favorites");
    }
    
    //append list to ul
    $("#fav-list").append(favli).promise().done(function () {
        $("#fav-list").listview("refresh");
        $('#fav-list').unbind('click');
        //add the click event for the redirection to happen to #details-page 
        $("#fav-list").on("click", ".info-go", function (e) {
          e.stopPropagation();
          e.preventDefault();
          var thisId = this.id;
          var thisInfo;
          BwtApp.getBWTData(function () {
            //******************** the below code gets port info from "info" json object ******************
            jQuery.map(BwtApp.info, function (obj) {
                       if (obj.port_number === thisId){
                         thisInfo = obj;
                       }
                       });
            
            //*******************  end code gets port info from "info" json object  ************************
            
            $("#details-page").data("info", thisInfo);
            
            $.mobile.changePage("#details-page", { transition: "fade" });
            
            });//end get bwt data
        });

        //************************************************* swipe works for iphone
        if(device.platform =='iOS'){
        var onswipe = false;
        $("#fav-list").on('swipeleft', ".info-go", function () {
                          
            var thisInfo;
            var thisElem = $(this);
            var thisId = this.id;
                          
            jQuery.map(BwtApp.info, function (obj) {
                if (obj.port_number === thisId){
                    
                    thisInfo = obj;
                       var listDetails = thisInfo;
                       console.log("Port Number: " + listDetails.port_number);
                       console.log("Port Name: " + listDetails.port_name);
                       var aElem = thisElem.attr("id");
                       
                       if (!onswipe) {
                           onswipe = true;
                           html = '<button type="button" class="btndelete ui-btn-corner-all ui-btn-up-e" data-role="button" data-theme="e">Delete</button>';
                           $(".btndelete").remove();
                       
                           thisElem.append(html);
                       
                           $(".btndelete").click(function (e) {
                                 thisElem.parent().remove();
                                 BwtApp.removeFromStorage(listDetails.port_number, listDetails.port_name);
                                 onswipe = false;
                                 $("#fav-list").listview("refresh");
                             });
                       }
                 }
                       
            });
           
        });

        //************************************************* end swiperight

        $("#fav-list").on('swiperight', ".info-go", function () {
            
              var thisInfo;
              var thisElem = $(this);
              var thisId = this.id;
              
              jQuery.map(BwtApp.info, function (obj) {
                         if (obj.port_number === thisId){
                              thisInfo = obj;
                              var listDetails = thisInfo;
                              console.log("Port Number: " + listDetails.port_number);
                              console.log("Port Name: " + listDetails.port_name);
                              var aElem = thisElem.attr("id");
                              console.log("aElem: " + aElem);
                              $(".btndelete").remove();
                              onswipe = false;
                         }
              });
        });
        }//end device ios

    });       
};

//*****************************  END FAVORITES PAGE    ****************************************************************************


//*****************************  START DETAILS PAGE    ****************************************************************************

$(document).on("pagebeforeshow", "#details-page", function () {   

   //get from data - you put this here when the "a" was clicked in the previous page
    var info = $(this).data("info");
    var info_view = "";
    var laneHead = "";
    var dataCollapsed = 'data-collapsed="true"';
    
    if (!BwtApp.hasInStorage(info.port_number)) {
        $(".addToFavoritesDiv").show();
        if(device.platform=='Android'){
            $(".removeFromFavoritesDiv").hide();
        }
    }
    else {
        $(".addToFavoritesDiv").hide();
        if(device.platform=='Android'){
            $(".removeFromFavoritesDiv").show();
        }
    }
    var port_status = info.port_status;
    var port_hrs = info.hours;
    var info_port= "";
    
    info_view = "<span style='font-size:small;'>" + info.port_name + "</span>";

    if (info.crossing_name !== "" && info.crossing_name !== undefined) {
        info_port += "<div style='font-size:14px; text-align:center;font-weight:bold;margin-bottom:5px;color:#666666'> " + info.crossing_name + "</div>";
    }
    info_port += "<span style='font-size:small; float:left;'><i>";
    info_port += "<b>Hours:</b> " + port_hrs + "</i></span>";
    info_port += "<span style='font-size:small; float:right;'><i><b>Status:</b> ";
    if(port_status.toLowerCase() === "open"){
       info_port +=  "<span style='color: #339900;'>" + port_status + "</span>";
    }
    else if(port_status.toLowerCase() === "closed"){
       info_port +=  "<span style='color: #cc0033;'>" + port_status + "</span>";
    }
    info_port += "</i></span><br/>";

    //add this to html
    $("#details-page").find("#details").html(info_port);

    $("#details-page").find("#detailheader").html(info_view);

    $("#details-page").find("#noticeText").html("<p><span style='font-size:small'><i>" + info.construction_notice + "</i></span></p>");
    /******************************COMMERCIAL*******************************************/
    var covText = "";
    if (info.commercial_vehicle_lanes.maximum_lanes != "N/A") {
        //this is the detail for the lane type
        $updatetime = info.commercial_vehicle_lanes.standard_lanes.update_time;
        $headerdelay = "";
        if ($updatetime === "") {
            $updatetime = info.commercial_vehicle_lanes.FAST_lanes.update_time;

        }
        $updatetime = $updatetime.replace("At", "Updated");        

        $sdelay = info.commercial_vehicle_lanes.standard_lanes.delay_minutes;        
        $fdelay = info.commercial_vehicle_lanes.FAST_lanes.delay_minutes;
        if ($sdelay !== "") {
            $headerdelay = $sdelay < 10 ? "< 10 min" : $sdelay + " min";
            $headerdelay += '<br/><span style="font-size:x-small"><i>(Std)</i>';
        }
        if ($headerdelay === "" && $fdelay !== "") {
            $headerdelay = $fdelay < 10 ? "< 10 min" : $fdelay + " min";
            $headerdelay += '<br/><span style="font-size:x-small"><i>(FAST)</i>';
        }
        

        if (info.commercial_vehicle_lanes.standard_lanes.operational_status != "N/A") {
            if (info.commercial_vehicle_lanes.standard_lanes.operational_status == "Lanes Closed") {
                covText += "<div style='float:left; width:65%; margin-bottom:5px; '>Standard </div><div style='text-align:right; margin-bottom:5px; color: #cc0033;'>Closed</div>";
                if($headerdelay==="")$headerdelay='Closed<br/><span style="font-size:x-small"><i>(Std)</i>';
            }
            else if (info.commercial_vehicle_lanes.standard_lanes.operational_status === "Update Pending") {
                covText += "<div style='float:left; width:65%; margin-bottom:5px; '>Standard </div><div style='text-align:right; margin-bottom:5px;'>Pending</div>";
                if ($headerdelay === "") $headerdelay = 'Pending<br/><span style="font-size:x-small"><i>(Std)</i>';
            }
            else {
                laneHead = "";
                laneHead = info.commercial_vehicle_lanes.standard_lanes.lanes_open === "1" ? " Lane:": " Lanes:";
                covText += "<div style='float:left; width:65%; margin-bottom:5px;background-color:#ffffff;'>Standard - " + info.commercial_vehicle_lanes.standard_lanes.lanes_open + " " + laneHead + " </div><div style='text-align:right; margin-bottom:5px; background-color:" + BwtApp.getColor($sdelay) + ";border-right:5px solid " + BwtApp.getSideColor($sdelay) + ";'><b style='padding-right:3px;'>" + ($sdelay < 10 ? "< 10 min" : $sdelay + " min") + "</b></div>";
            }
        }
        if (info.commercial_vehicle_lanes.FAST_lanes.operational_status != "N/A") {
           
            if(info.commercial_vehicle_lanes.FAST_lanes.operational_status == "Lanes Closed"){
                covText += "<div style='float:left; width:65%; '>FAST </div><div style='text-align:right; color: #cc0033;'>Closed</div>";
                if ($headerdelay === "") $headerdelay = 'Closed<br/><span style="font-size:x-small"><i>(FAST)</i>';
            }
            else if (info.commercial_vehicle_lanes.FAST_lanes.operational_status == "Update Pending") {
                covText += "<div style='float:left; width:65%; '>FAST </div><div style='text-align:right;'>Pending</div>";
                if ($headerdelay === "") $headerdelay = 'Pending<br/><span style="font-size:x-small"><i>(FAST)</i>';
            }
            else {
               laneHead = "";
               laneHead = info.commercial_vehicle_lanes.FAST_lanes.lanes_open === "1" ? " Lane:": " Lanes:";
                covText += "<div style='float:left; width:65%;margin-bottom:5px;background-color:#ffffff;'>FAST - " + info.commercial_vehicle_lanes.FAST_lanes.lanes_open + " " + laneHead + " </div><div style='text-align:right; background-color:" + BwtApp.getColor($fdelay) + ";border-right:5px solid " + BwtApp.getSideColor($fdelay) + ";'><b style='padding-right:3px;'>" + ($fdelay < 10 ? "< 10 min" : $fdelay + " min") + "</b></div>";
            }
        }

        if (covText !== "") {
            var cov = '<div data-role="collapsible" data-theme="b"  data-mini= "true" data-content-theme="a" ' + dataCollapsed  +' id="comm">';
            cov += '<h4><span id="h4TextCov"></span></h4>';
            cov += '<p></p>';
            cov += '</div>';
            $("#details-page").find("#details").append(cov).trigger("create");
            covheader = '<span style="float: left;">Commercial<br/><span style="font-size:x-small"><i>' + $updatetime + '</i></span></span><span style="float: right; text-align:center;">' + $headerdelay + '</span>';
            $("#details-page").find("#comm #h4TextCov").html(covheader);//work on this
            $("#details-page").find("#comm").find("p").html(covText);//work on this
        }
    }
    /***********************************PASSENGER***********************************************************/
    var povText = "";
    if (info.passenger_vehicle_lanes.maximum_lanes != "N/A") {
        $headerdelay = "";
        $updatetime = info.passenger_vehicle_lanes.standard_lanes.update_time;
        if ($updatetime === "") {
            $updatetime = info.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.update_time;
        }
        if ($updatetime === "") {
            $updatetime = info.passenger_vehicle_lanes.ready_lanes.update_time;
        }
        $updatetime = $updatetime.replace("At", "Updated");
        
        $laneType = "Nexus";
        if (info.border === 'Mexican Border') {
            $laneType = "Sentri";
        }
        $sdelay = info.passenger_vehicle_lanes.standard_lanes.delay_minutes;
        $ndelay = info.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.delay_minutes; 
        $rdelay = info.passenger_vehicle_lanes.ready_lanes.delay_minutes;
        if ($sdelay !== "") {
            $headerdelay = $sdelay < 10 ? "< 10 min" : $sdelay + " min";
            $headerdelay += '<br/><span style="font-size:x-small"><i>(Std)</i>';
        }
        if ($headerdelay === "" && $ndelay !== "") {
            $headerdelay = $ndelay < 10 ? "< 10 min" : $ndelay + " min";
            $headerdelay += '<br/><span style="font-size:x-small"><i>('+ $laneType +')</i>';
        }
        if ($headerdelay === "" && $rdelay !== "") {
            $headerdelay = $rdelay < 10 ? "< 10 min" : $rdelay + " min";
            $headerdelay += '<br/><span style="font-size:x-small"><i>(Ready)</i>';
        }

        if (info.passenger_vehicle_lanes.standard_lanes.operational_status != "N/A") {
            if (info.passenger_vehicle_lanes.standard_lanes.operational_status == "Lanes Closed") {
                povText += "<div style='float:left; width:65%; margin-bottom:5px; '>Standard </div><div style='text-align:right; margin-bottom:5px; color: #cc0033;'>Closed</div>";
                if ($headerdelay === "") $headerdelay = 'Closed<br/><span style="font-size:x-small"><i>(Std)</i>';
            }
            else if (info.passenger_vehicle_lanes.standard_lanes.operational_status == "Update Pending") {
                povText += "<div style='float:left; width:65%; margin-bottom:5px; '>Standard </div><div style='text-align:right; margin-bottom:5px;'>Pending</div>";
                if ($headerdelay === "") $headerdelay = 'Pending<br/><span style="font-size:x-small"><i>(Std)</i>';
            }
            else{
               laneHead = "";
               laneHead = info.passenger_vehicle_lanes.standard_lanes.lanes_open === "1" ? " Lane:": " Lanes:";
                povText += "<div style='float:left; width:65%; margin-bottom:5px;background-color:#ffffff;'>Standard - " + info.passenger_vehicle_lanes.standard_lanes.lanes_open + " " + laneHead + " </div><div style='text-align:right; margin-bottom:5px;background-color:" + BwtApp.getColor($sdelay) + ";border-right:5px solid" + BwtApp.getSideColor($sdelay) + ";'><b style='padding-right:3px;'>" + ($sdelay < 10 ? "< 10 min" : $sdelay + " min") + "</b></div>";
            }
        }
        if (info.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.operational_status != "N/A") {            

            if(info.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.operational_status == "Lanes Closed"){
                povText += "<div style='float:left; width:65%; margin-bottom:5px;'>" + $laneType + " </div><div style='text-align:right; margin-bottom:5px; color: #cc0033;'>Closed</div>";
                if ($headerdelay === "") $headerdelay = 'Closed<br/><span style="font-size:x-small"><i>(' + $laneType +')</i>';
            }
            else if (info.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.operational_status == "Update Pending") {
                povText += "<div style='float:left; width:65%; margin-bottom:5px;'>" + $laneType + " </div><div style='text-align:right; margin-bottom:5px;'>Pending</div>";
                if ($headerdelay === "") $headerdelay = 'Pending<br/><span style="font-size:x-small"><i>(' + $laneType + ')</i>';
            }
            else{
               laneHead="";
               laneHead = info.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.lanes_open === "1" ? " Lane:": " Lanes:";
                povText += "<div style='float:left; width:65%; margin-bottom:5px;background-color:#ffffff;'>" + $laneType + " - " + info.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.lanes_open + " " + laneHead + " </div><div style='text-align:right; margin-bottom:5px; background-color:" + BwtApp.getColor($ndelay) + ";border-right:5px solid " + BwtApp.getSideColor($ndelay) + ";'><b style='padding-right:3px;'>" + ($ndelay < 10 ? "< 10 min" : $ndelay + " min") + "</b></div>";
            }
        }

        if (info.passenger_vehicle_lanes.ready_lanes.operational_status !== "N/A") {

            if(info.passenger_vehicle_lanes.ready_lanes.operational_status === "Lanes Closed"){
                povText += "<div style='float:left; width:65%; margin-bottom:5px; '>Ready </div><div style='text-align:right; margin-bottom:5px; color: #cc0033;' >Closed</div>";
                if ($headerdelay === "") $headerdelay = 'Closed<br/><span style="font-size:x-small"><i>(Ready)</i>';
            }
            else if (info.passenger_vehicle_lanes.ready_lanes.operational_status == "Update Pending") {
                povText += "<div style='float:left; width:65%; margin-bottom:5px; '>Ready </div><div style='text-align:right; margin-bottom:5px;'>Pending</div>";
                if ($headerdelay === "") $headerdelay = 'Pending<br/><span style="font-size:x-small"><i>(Ready)</i>';
            }
            else{
               laneHead = "";
               laneHead = info.passenger_vehicle_lanes.ready_lanes.lanes_open === "1" ? " Lane:": " Lanes:";
                povText += "<div style='float:left; width:65%; margin-bottom:5px;background-color:#ffffff;'>Ready - " + info.passenger_vehicle_lanes.ready_lanes.lanes_open + " " + laneHead + " </div><div style='text-align:right; margin-bottom:5px; background-color:" + BwtApp.getColor($rdelay) + ";border-right:5px solid " + BwtApp.getSideColor($rdelay) + ";'><b style='padding-right:3px;'>" + ($rdelay < 10 ? "< 10 min" : $rdelay + " min") + "</b></div>";
            }
        }

        if (povText !== "") {
            var pov = '<div data-role="collapsible" data-theme="b" data-mini= "true" data-content-theme="a" ' + dataCollapsed + ' id="pov">';
            pov += '<h4><span id="h4TextPov"></span></h4>';
            pov += '<p></p>';
            pov += '</div>';
            $("#details-page").find("#details").append(pov).trigger("create");
            povheader = '<span style="float: left;">Passenger<br/><span style="font-size:x-small"><i>' + $updatetime + '</i></span></span><span style="float: right; text-align:center;">' + $headerdelay + '</span>';
            $("#details-page").find("#pov #h4TextPov").html(povheader);//work on this
            $("#details-page").find("#pov").find("p").html(povText);//work on this
        }
    }

    var pedText = "";
    if (info.pedestrian_lanes.maximum_lanes != "N/A") {
        $headerdelay = "";
        $updatetime = info.pedestrian_lanes.standard_lanes.update_time;
        if ($updatetime === "") {
            $updatetime = info.pedestrian_lanes.ready_lanes.update_time;
        }
        $updatetime = $updatetime.replace("At", "Updated");
      

        $sdelay = info.pedestrian_lanes.standard_lanes.delay_minutes; 
        $rdelay = info.pedestrian_lanes.ready_lanes.delay_minutes;

        if ($sdelay !== "") {
            $headerdelay = $sdelay < 10 ? "< 10 min" : $sdelay + " min";
            $headerdelay += '<br/><span style="font-size:x-small"><i>(Std)</i>';
        }        
        if ($headerdelay === "" && $rdelay !== "") {
            $headerdelay = $rdelay < 10 ? "< 10 min" : $rdelay + " min";
            $headerdelay += '<br/><span style="font-size:x-small"><i>(Ready)</i>';
        }
       

        if (info.pedestrian_lanes.standard_lanes.operational_status !== "N/A") {

            if (info.pedestrian_lanes.standard_lanes.operational_status === "Lanes Closed") {
                pedText += "<div style='float:left; width:65%; margin-bottom:5px; '>Standard </div><div style='text-align:right; margin-bottom:5px; color: #cc0033;'>Closed</div>";
                if ($headerdelay === "") $headerdelay = 'Closed<br/><span style="font-size:x-small"><i>(Std)</i>';
            }
            else if (info.pedestrian_lanes.standard_lanes.operational_status === "Update Pending") {
                pedText += "<div style='float:left; width:65%; margin-bottom:5px; '>Standard </div><div style='text-align:right; margin-bottom:5px;'>Pending</div>";
                if ($headerdelay === "") $headerdelay = 'Pending<br/><span style="font-size:x-small"><i>(Std)</i>';
            }
            else {
               laneHead = "";
               laneHead = info.pedestrian_lanes.standard_lanes.lanes_open === "1" ? " Lane:": " Lanes:";
                pedText += "<div style='float:left; width:65%; margin-bottom:5px;background-color:#ffffff;'>Standard - " + info.pedestrian_lanes.standard_lanes.lanes_open + " " + laneHead + " </div><div style='text-align:right; margin-bottom:5px; background-color:" + BwtApp.getColor($sdelay) + ";border-right:5px solid" + BwtApp.getSideColor($sdelay) + ";'><b style='padding-right:3px;'>" + ($sdelay < 10 ? "< 10 min" : $sdelay + " min") + "</b></div>";
            } 
        }
        if (info.pedestrian_lanes.ready_lanes.operational_status !== "N/A") {

            if(info.pedestrian_lanes.ready_lanes.operational_status === "Lanes Closed"){
                pedText += "<div style='float:left; width:65%; margin-bottom:5px; '>Ready </div><div style='text-align:right; margin-bottom:5px; color: #cc0033;' >Closed</div>";
                if ($headerdelay === "") $headerdelay = 'Closed<br/><span style="font-size:x-small"><i>(Ready)</i>';
            }
            else if (info.pedestrian_lanes.ready_lanes.operational_status === "Update Pending") {
                pedText += "<div style='float:left; width:65%; margin-bottom:5px; '>Ready </div><div style='text-align:right; margin-bottom:5px;'>Pending</div>";
                if ($headerdelay === "") $headerdelay = 'Pending<br/><span style="font-size:x-small"><i>(Ready)</i>';
            }
            else{
               laneHead = "";
               
               laneHead = info.pedestrian_lanes.ready_lanes.lanes_open === "1" ? " Lane:": " Lanes:";
                pedText += "<div style='float:left; width:65%; margin-bottom:5px;background-color:#ffffff;'>Ready - " + info.pedestrian_lanes.ready_lanes.lanes_open + " " + laneHead + " </div><div style='text-align:right; margin-bottom:5px; background-color:" + BwtApp.getColor($rdelay) + ";border-right:5px solid " + BwtApp.getSideColor($rdelay) + ";'><b style='padding-right:3px;'>" + ($rdelay < 10 ? "< 10 min" : $rdelay + " min") + "</b></div>";
            }  
        }

        if (pedText !== "") {
            var ped = '<div data-role="collapsible" data-theme="b" data-mini="true" data-content-theme="a" ' + dataCollapsed + ' id="ped">';
            ped += '<h4><span id="h4TextPed"></span></h4>';
            ped += '<p></p>';
            ped += '</div>';
            $("#details-page").find("#details").append(ped).trigger("create");
            pedheader = '<span style="float: left;">Pedestrian<br/><span style="font-size:x-small"><i>' + $updatetime + '</i></span></span><span style="float: right; text-align:center;">' + $headerdelay + '</span>';
            $("#details-page").find("#ped #h4TextPed").html(pedheader);//work on this
            $("#details-page").find("#ped").find("p").html(pedText);//work on this
        }
    }
    //the code below needs  to be tested
    if (covText === "" && povText === "" && pedText === "") {
        var portMsg = "<br/>All Lanes closed";
        $("#details-page").find("#details").append(portMsg);
    }
    
    $(".addToFavoritesDiv a").attr('id', info.port_number);
    var addFav = $(".addToFavoritesDiv a").attr('id');    
    console.log("Add ID value: ");
    $(".addToFavoritesDiv").unbind("click");//
    $(".addToFavoritesDiv" ).on("click", "#" + addFav, function (e) {
        //e.isDefaultPrevented();
        e.preventDefault();        
        console.log("The paragraph was clicked.");
        var portNum = info.port_number;
        var label = info.port_name;
        console.log("The paragraph was clicked. " + portNum);
        console.log("The paragraph was clicked. " + label);
        BwtApp.addToStorage(portNum, label);
        $.mobile.changePage("#fav-page", {transition:"slide"});
    });
    
    if(device.platform=='Android' && BwtApp.hasInStorage(info.port_number))
    {
       $(".removeFromFavoritesDiv a").attr('id', info.port_number);
        var removeFav = $(".removeFromFavoritesDiv a").attr('id');
               //console.log("Remove ID value: ");
               $(".removeFromFavoritesDiv").unbind("click");//
               $(".removeFromFavoritesDiv" ).on("click", "#" + removeFav, function (e) {
                   e.preventDefault();
                   //console.log("Remove was clicked.");
                   var portNum = info.port_number;
                   var label = info.port_name;
                   //console.log("Remove was clicked. " + portNum);
                   //console.log("Remove was clicked. " + label);
                   BwtApp.removeFromStorage(portNum, label);
                   $.mobile.changePage("#fav-page", {transition:"slide"});
                });
    }
               

    //slow down the collapsible
    $(".ui-collapsible .ui-collapsible-heading-toggle").bind("click", function (e) {
        var current = $(this).closest(".ui-collapsible");
        if (current.hasClass("ui-collapsible-collapsed")) {
            $(".ui-collapsible-content", current).slideDown("slow", function () {
                current.trigger("collapsibleexpand");
            });
        } else {
            $(".ui-collapsible-content", current).slideUp("slow", function () {
                current.trigger("collapsiblecollapse");
            });
        }
    });

});

//************   END DETAILS PAGE   **********************************

//******************  START startuppage choice  *********************************

$(document).on("pagebeforeshow", "#startupChoicePage", function () {
    BwtApp.startupPage = BwtApp.getItemFromStorage("startPg");

    $(":radio").unbind("change").bind("change", function (event) {
        var value = $("input[name=startPg]:checked").val();
       
        BwtApp.addToStorage("startPg", value);
    });
    $("input:radio[name=startPg][value=" + BwtApp.startupPage + "]").attr('checked', true).click();
   
});

//******************  END startuppage choice  *********************************

//*****************    START refresh choice page   ***************************
$(document).on("pagebeforeshow", "#refreshChoicePage", function () {

    refreshRate = BwtApp.getItemFromStorage("refreshRate");

    $(":radio[name=refreshRate]").unbind("change").bind("change", function (event) {
        var value = $("input[name=refreshRate]:checked").val();
        BwtApp.addToStorage("refreshRate", value);
    });
   $("input:radio[name=refreshRate][value=" + refreshRate + "]").prop('checked', true).click();

});
//*****************    END refresh choice page   ***************************

//**************************  Map related code starts here  *********************************


var BingMapsKey = "As88Ealcwz5JRC99ZUg74RmBFBA0rW7gs8fkos4loqYeKWKQJkuz4iBrLE1IEZUd";

var map = null;
var userLat='';
var userLong='';
var mapinfo = null;

BwtApp.locationConfirm = function (previousPage) {
    var allow = false;
    $("#useLocationDialog").unbind("click");
    $("#useLocationDialog").on("click", ".locBtnConfirmYes", function (e) {
        e.preventDefault();
        allow = true;
        BwtApp.addToStorage("allowLocationRead", "yes");
        $.mobile.changePage("#nearestPorts", { allowSamePageTransition: true, transition: "slide" });
    });
    $("#useLocationDialog").on("click", ".locBtnConfirmNo", function (e) {
        e.preventDefault();
        $.mobile.changePage("#" + previousPage, { transition: "slide" });
    });
    return allow;
};

BwtApp.showError = function(error) {
    //alert("geolocation error: " + error.code);
    userLat="";
    userLong="";
    document.getElementById("output").innerHTML = "";
    if (map !== null) { map.dispose(); }
    document.getElementById("locationsLink").style.display="none";
    
    if(error.code == 1){
        //permission denied
        navigator.notification.alert("Your Location services are currently disabled.", null, "BWT", "OK");
    }else if(error.code == 2){
        //Location unavailable
        navigator.notification.alert("Location information is not available at this time.", null, "BWT", "OK");
    }
    else if(error.code == 3){
        //request timeout.
        navigator.notification.alert("Your request for location has timed out. \n\nPlease verify that there is a network connection and that the Location setting on your phone is turned on.", null, "BWT", "OK");
    }
    
};

BwtApp.showPosition = function(position) {
    userLat = position.coords.latitude;
    userLong = position.coords.longitude;
    if (userLat !== "" && userLong !== "") {
        //userLat = 51.048615;
        //userLong = -114.070846 ;
        Search(userLat, userLong);
        
    }
};

BwtApp.getLocation = function() {
    if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(BwtApp.showPosition, BwtApp.showError, { enableHighAccuracy: true, maximumAge:12000, timeout:10000 });
    }
    else {
        navigator.notification.alert("Geolocation is not supported.", null, "BWT", "OK");
    }
};


$(document).on("pagebeforeshow", "#nearestPorts", function (event, data) {
    BwtApp.getLocation();
});

$(window).on( "orientationchange", function( event ) {
   //alert( "This device is in " + event.orientation + " mode!" );
   var activePage = $.mobile.activePage[0].id;
   if (activePage === "nearestPorts") {
        BwtApp.getLocation();
   }
});



//Make a REST request for the Bing Map REST Services and Bing Spatial Data Services
function MakeServiceRequest(request) {
    var script = document.createElement("script");
    script.setAttribute("type", "text/javascript");
    script.setAttribute("src", request);
    document.body.appendChild(script);
}

//Geocode the location specified by the user
function Geocode() {
    //Create Bing Maps REST Services request to geocode the address provided by the user
    var geocodeRequest = "http://dev.virtualearth.net/REST/v1/Locations/" +
        document.getElementById('address').value +
        "?output=json" +
       //Set the callback function
        "&jsonp=GetLocationCoordinates" +
        "&key=" + BingMapsKey;
    //Submit the request
    MakeServiceRequest(geocodeRequest);
}

//Get the geocoded latitude and longitude from the response
function GetLocationCoordinates(geocodeResponse) {
    if (geocodeResponse &&
           geocodeResponse.resourceSets &&
           geocodeResponse.resourceSets.length > 0 &&
           geocodeResponse.resourceSets[0].resources &&
           geocodeResponse.resourceSets[0].resources.length > 0) {

        Search(geocodeResponse.resourceSets[0].resources[0].point.coordinates[0], geocodeResponse.resourceSets[0].resources[0].point.coordinates[1]);
       
    }
    else {
        document.getElementById("output").innerHTML = "";
        var output = document.getElementById("output");
        resultsHeader.innerHTML = "The location could not be geocoded";
    }
}

// Search the data source for entities within "distance" of the geocoded location ("lat","long").
function Search(lat, long) {
    //distance to search in km bing maps max is 1000km.
    var distance = 1000;
    
    var requestStr = "https://spatial.virtualearth.net/REST/v1/data/81bfbad5e3f3449284ea4ff34d0bfa72/BWT/BorderWaitTimes?" +
     "spatialFilter=nearby(" + lat + "," + long + "," + distance + ")" +
     "&$select=BwtID,Latitude,Longitude,PortName,CrossingName,__Distance&$top=3" +
     "&$format=json" +
     "&key=" + BingMapsKey +
    // set the JSON callback function
     "&Jsonp=MapResults";
    //Submit reqquest
    MakeServiceRequest(requestStr);
}
var start;
var end;
var endLocNm;

function getMiles(kmDist) {
    var miles = (kmDist * 0.621371).toString();
    return miles.slice(0, (miles.lastIndexOf(".") + 3));
    //return miles;
}

var results; //Nearest results
var routeDistance;
var travelTime;
var endLocationPinIndex;


//Show results (up to 3) and put them on the map
function MapResults(response) {
    //Display list of results
    document.getElementById("output").innerHTML = "";
    
    var output = document.getElementById("output");    
    
    var resultsList = document.createElement("ol");
    
    output.appendChild(resultsList);

    //Create pushpin collection to display on the map
    var pushpins = new Microsoft.Maps.EntityCollection();
    var infoboxLayer = new Microsoft.Maps.EntityCollection();
    
    if (map !== null) { map.dispose(); }
    var deviceWidth = (window.innerWidth > 0) ? window.innerWidth : screen.width;
    map = new Microsoft.Maps.Map(document.getElementById("mapDiv"), { credentials: BingMapsKey, height: 300, width: deviceWidth, showScalebar: false, showDashboard: false, enableSearchLogo: false, mapTypeId: "r" });
    results = null;
    
    //Check if there are results
    if (response.d.results.length !== 0) {
        //Get the search results
        results = response.d.results;

        //initialize bounds for map area 
        var minLatitude = results[0].Latitude; var maxLatitude = results[0].Latitude;
        var minLongitude = results[0].Longitude; var maxLongitude = results[0].Longitude;

        // Display results header
        var resultsListItem = null;
        var resultStr = "";

        //Display each entity and create a pushpin for the map
        for (var i = 0; i < results.length; ++i) {
            resultsListItem = document.createElement("li");
            resultsList.appendChild(resultsListItem);

            //******************************  Get Distance   ********************

            var toLat = results[i].Latitude;
            var toLong = results[i].Longitude;
            
            var fromLat = userLat;
            var fromLong = userLong;
            
            var distStart = fromLat + "," + fromLong;
            var distEnd = toLat + "," + toLong;
            
            var distanceElId = "travelDistance" + i;

            getDistance(distStart, distEnd, distanceElId, function (distance, currentElId) {
                console.log("distance: " + getMiles(distance));
                        //alert("distance: " + getMiles(distance));
                        //alert("currentElId: " + currentElId);
                $("#" + currentElId).html(getMiles(distance) + " miles.");
                        });
            
               
            //******************************  End Get Distance  ********************
            //pb added 12/24/2014 this opens the directions in the browser<a href='http://maps.apple.com/?daddr=" + distEnd + "&saddr="  + fromLat + "," + fromLong + "'>Directions</a>

            /*commented to remove the map route functionality from the app. Using Navigate as of 02/27/2015
             
             resultStr = results[i].PortName + " <i>"
            + results[i].CrossingName + "</i><br/><span id='" +  distanceElId + "'></span>&nbsp;<a href='#' id='" + i + "' class='mapRoute'>Map Route</a>&nbsp;&nbsp;&nbsp;<a href='#' id='" + i + "' class='mapDirections'>Navigate</a><br/><br/></li>";*/
            
            resultStr = results[i].PortName + " <i>" +
             results[i].CrossingName + "</i><br/><span id='" +  distanceElId + "'></span>&nbsp;<a href='#' id='" + i + "' class='mapDirections'>Navigate</a><br/><br/></li>";
            resultsListItem.innerHTML = resultStr;
            //alert(resultStr);
            
            // Add pushpin to map collection
            var pushpinVal = (i + 1).toString();
            var pin = new Microsoft.Maps.Pushpin(new Microsoft.Maps.Location(results[i].Latitude, results[i].Longitude), { text: pushpinVal, icon: 'Content/images/mappin.png', zIndex:"10"});
            
            Microsoft.Maps.Events.addHandler(pin, 'click', ShowInfo);            

            pushpins.push(pin);

            //Determine bounds that display all pushpins
            if (results[i].Latitude > maxLatitude)
            { maxLatitude = results[i].Latitude; }
            else if (results[i].Latitude < minLatitude)
            { minLatitude = results[i].Latitude; }

            if (results[i].Longitude > maxLongitude)
            { maxLongitude = results[i].Longitude; }
            else if (results[i].Longitude < minLongitude)
            { minLongitude = results[i].Longitude; }
                        
        }//end for
        
        //add pin for users current location
        var curLocPin = new Microsoft.Maps.Pushpin(new Microsoft.Maps.Location(userLat, userLong), { text: "A", icon: 'Content/images/mappin.png', zIndex:"10" });
        Microsoft.Maps.Events.addHandler(curLocPin, 'click', ShowCurInfo);
        pushpins.push(curLocPin);

        //Create map using the AJAX 7 map control
        mapDiv.style.visibility = "visible";        
        
        //Add the entity pushpins to the map
        map.entities.push(pushpins);
        
        map.entities.push(infoboxLayer);
        
        mapinfo = new Microsoft.Maps.Infobox(new Microsoft.Maps.Location(0, 0), { visible: false, offset: new Microsoft.Maps.Point(0, 20) });
        infoboxLayer.push(mapinfo);

        //Determine bounds that display all pushpins including users current location.
        if (userLat > maxLatitude)
        { maxLatitude = userLat; }
        else if (userLat < minLatitude)
        { minLatitude = userLat; }

        if (userLong > maxLongitude)
        { maxLongitude = userLong; }
        else if (userLong < minLongitude)
        { minLongitude = userLong; }


        //Add padding to map area so that pushpins are not on the edge
        minLatitude -= 0.0001;
        maxLatitude += 0.5001;
        minLongitude -= 0.0001 ;
        maxLongitude += 0.5001;
        var mapArea = Microsoft.Maps.LocationRect.fromLocations(new Microsoft.Maps.Location(minLatitude, minLongitude), new Microsoft.Maps.Location(maxLatitude, maxLongitude));
        map.setView({ bounds: mapArea });
        
        document.getElementById("locationsLink").style.display="inline";
        
        $("a.mapDirections").click(function (e) {
                                   
           start = "";
           end = "";
           startLocNm = "";
           endLocNm = "";
           
           e.preventDefault();
           var pinIndex = $(this).attr("id");
           
           var toLat = results[pinIndex].Latitude;
           var toLong = results[pinIndex].Longitude;
           
           var fromLat = userLat;
           var fromLong = userLong;
           
           start = fromLat + "," + fromLong;
           end = toLat + "," + toLong;
           endLocationPinIndex = pinIndex;
           endLocNm = results[pinIndex].PortName + " " + results[pinIndex].CrossingName;
           //the below code opens the directions in the default map app. vvGood - ios only
           if(device.platform ==='iOS'){
               window.location.href = "maps://maps.apple.com/?q=" + end;
           }
           if(device.platform ==='Android'){
              window.location.href = "geo://0,0?q=" + end;
           }
                                   
       });
        
        //****************************Show route on map***************************************

        /* Removed the map route functionality - 02/27/2015
         
         $("a.mapRoute").click(function (e) {

            start = "";
            end = "";
            startLocNm = "";
            endLocNm = "";
                              
            e.preventDefault();
            var pinIndex = $(this).attr("id");
                              
            var toLat = results[pinIndex].Latitude;
            var toLong = results[pinIndex].Longitude;

            var fromLat = userLat;
            var fromLong = userLong;

            start = fromLat + "," + fromLong;
            end = toLat + "," + toLong;
            endLocationPinIndex = pinIndex;
            endLocNm = results[pinIndex].PortName + " " + results[pinIndex].CrossingName;
            getDirections();
        });*/
        
        
        $("#showLocations").unbind("click").bind("click",function (e) {
            MapResults(response);
        });
        //******************************end show route on map*************************************

    }
    else { //No results were returned
        var result = document.getElementById("output");
        result.innerHTML = "No locations were found within 600 miles from your location.";
        result.style.color = "DarkRed";
        result.style.fontFamily = "sans-serif";
        result.style.fontWeight = "normal";
        result.style.padding = "15px";
        //map.dispose();
    }
}//end MapResults


function getDistance(diststart, distend, currentElId, fn) {
    
    $.ajax({
        type: 'GET',
        url: 'http://dev.virtualearth.net/REST/v1/Routes?wp.0=' + diststart + '&wp.1=' + distend + '&key=' + BingMapsKey + '&routePathOutput=Points&output=json&jsonp=?',
        crossDomain: true,
        contentType: "application/json; charset=utf-8",
        dataType: "jsonp",        
        success: function (dresult) {            
            routeDistance = 0;
            if (dresult && dresult.resourceSets && dresult.resourceSets.length > 0 && dresult.resourceSets[0].resources && dresult.resourceSets[0].resources.length > 0) {
                routeDistance = dresult.resourceSets[0].resources[0].routeLegs[0].travelDistance;
                travelTime = dresult.resourceSets[0].resources[0].routeLegs[0].travelDuration;
                var travelTimeTraffic = dresult.resourceSets[0].resources[0].routeLegs[0].travelDurationTraffic;                
                if (fn) fn(routeDistance, currentElId);
           
            }            
        },
        error: function (xhr, status, error) {
            console.log('Error! Could not get distance data.');
        },
        async: true,
        cache: false
    });
}


function callDistRouteService(credentials) {
    $.getJSON('http://dev.virtualearth.net/REST/v1/Routes?wp.0=' + diststart + '&wp.1=' + distend + '&key=' + BingMapsKey + '&routePathOutput=Points&output=json&jsonp=?', function (dresult) {
        if (dresult && dresult.resourceSets && dresult.resourceSets.length > 0 && dresult.resourceSets[0].resources && dresult.resourceSets[0].resources.length > 0) {

            routeDistance = dresult.resourceSets[0].resources[0].routeLegs[0].travelDistance + " " + dresult.resourceSets[0].resources[0].distanceUnit;
            travelTime = dresult.resourceSets[0].resources[0].routeLegs[0].travelDuration;
            var travelTimeTraffic = dresult.resourceSets[0].resources[0].routeLegs[0].travelDurationTraffic;
        }
    });
}


function ShowCurInfo(e) {
    var pin = e.target;
    var location = pin.getLocation();    

    var pushpinFrameHTML = '<div class="infobox" style="width:100px">' +
    '<a class="infobox_close" href="javascript:closeInfobox()"><img src="Content/images/boxCloseSM.png"/></a>' +
    '<div class=infobox_content">{content}</div></div><div class="infobox_pointer"><img src="Content/images/boxArrow.png" border="0"/></div>';

    var html = "<span class='portObjbox_title'><b>You are here</b></span>";

    RemoveOldEventHandlers(mapinfo);

    mapinfo.setOptions({
        visible: true,
        //offset: new Microsoft.Maps.Point(0, pin.getHeight()),
        offset: new Microsoft.Maps.Point(-33, 20),
        htmlContent: pushpinFrameHTML.replace('{content}', html)
    });

    map.setView({
        //zoom: 10,
        center: location,
        centerOffset: new Microsoft.Maps.Point(-80, 100)
    });

    mapinfo.setLocation(pin.getLocation());
}

function ShowInfo(e) {
    var pin = e.target; 
    var location = pin.getLocation();
    if(isNaN(pin.getText())){
        //this is used for map route info box based on the index of the end location which is a global variable.
        $bwtId = results[endLocationPinIndex].BwtID;
    }
    else{
        $bwtId = results[pin.getText() - 1].BwtID;
    }
    

    //******************** the below code gets port info from "info" json object ******************
    var portObject = null;
    jQuery.map(BwtApp.info, function (obj) {
        if (obj.port_number === $bwtId)
            portObject = obj;
               
    }); 
    //*******************  end code gets port info from "info" json object  ************************

    var pushpinFrameHTML = '<div class="infobox">' +
    '<a class="infobox_close" href="javascript:closeInfobox()"><img src="Content/images/boxCloseSM.png"/></a>' +
    '<div class=infobox_content">{content}</div></div><div class="infobox_pointer"><img src="Content/images/boxArrow.png" border="0"/></div>';

    var html = getPortDetails(portObject);

    RemoveOldEventHandlers(mapinfo);
    
    mapinfo.setOptions({
        visible: true,
        zIndex:20,
        //offset: new Microsoft.Maps.Point(0, pin.getHeight()),
        offset: new Microsoft.Maps.Point(-33, 20),
        htmlContent: pushpinFrameHTML.replace('{content}', html)
    });
    
    map.setView({
        //zoom: 10,
        center: location,
        centerOffset:new Microsoft.Maps.Point(-80,100)
    });
    
    mapinfo.setLocation(pin.getLocation());
}

function closeInfobox() {
    mapinfo.setOptions({ visible: false });
}


function getPortDetails(portObj) {
    var html = "<span class='portObjbox_title'><b>" + portObj.port_name + "</b><br/>" + portObj.crossing_name + "</span><hr size='1' style='height:1px; color:#666;'/>";

    if (portObj.commercial_vehicle_lanes.maximum_lanes != "N/A") {
        html += "<div class='typeTitle'>Commercial</div>";
        //this is the detail for the lane type
        $sdelay = portObj.commercial_vehicle_lanes.standard_lanes.delay_minutes;
        $fdelay = portObj.commercial_vehicle_lanes.FAST_lanes.delay_minutes;

        if (portObj.commercial_vehicle_lanes.standard_lanes.operational_status != "N/A") {
            if (portObj.commercial_vehicle_lanes.standard_lanes.operational_status == "Lanes Closed") {
                html += "<div class='laneWait'>Standard:<div class='dataDisp' style='color: #cc0033;'><b>Closed</b></div></div>";
            }
            else if (portObj.commercial_vehicle_lanes.standard_lanes.operational_status == "Update Pending") {
                html += "<div class='laneWait'>Standard:<div class='dataDisp'><b>Pending</b></div></div>";
            }
            else {
                html += "<div class='laneWait'>Standard:";
                html += "<div class='dataDisp' style='background-color:" + BwtApp.getColor($sdelay) + ";border-right:5px solid " +
                    BwtApp.getSideColor($sdelay) + ";'><b>" + ($sdelay < 10 ? "< 10 min" : $sdelay + " min") + "</b></div></div>";
            }
        }
        if (portObj.commercial_vehicle_lanes.FAST_lanes.operational_status != "N/A") {

            if (portObj.commercial_vehicle_lanes.FAST_lanes.operational_status == "Lanes Closed") {
                html += "<div class='laneWait'>FAST:<div class='dataDisp' style='color: #cc0033;'><b>Closed</b></div></div>";
            }
            else if (portObj.commercial_vehicle_lanes.FAST_lanes.operational_status == "Update Pending") {
                html += "<div class='laneWait'>FAST:<div class='dataDisp'><b>Pending</b></div></div>";
            }
            else {
                html += "<div class='laneWait'>FAST:";
                html += "<div class='dataDisp' style='background-color:" + BwtApp.getColor($fdelay) + ";border-right:5px solid " +
                    BwtApp.getSideColor($fdelay) + ";'><b>" + ($fdelay < 10 ? "< 10 min" : $fdelay + " min") + "</b></div></div>";
            }
        }
    }
    /***********************************PASSENGER***********************************************************/

    if (portObj.passenger_vehicle_lanes.maximum_lanes != "N/A") {

        html += "<div class='typeTitle'>Passenger</div>";
        $laneType = "Nexus";
        if (portObj.border == 'Mexican Border') {
            $laneType = "Sentri";
        }
        $sdelay = portObj.passenger_vehicle_lanes.standard_lanes.delay_minutes;
        $ndelay = portObj.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.delay_minutes;
        $rdelay = portObj.passenger_vehicle_lanes.ready_lanes.delay_minutes;

        if (portObj.passenger_vehicle_lanes.standard_lanes.operational_status != "N/A") {
            if (portObj.passenger_vehicle_lanes.standard_lanes.operational_status == "Lanes Closed") {
                html += "<div class='laneWait'>Standard:<div class='dataDisp' style='color: #cc0033;'><b>Closed</b></div></div>";
            }
            else if (portObj.passenger_vehicle_lanes.standard_lanes.operational_status == "Update Pending") {
                html += "<div class='laneWait' >Standard:<div class='dataDisp'><b>Pending</b></div></div>";
            }
            else {
                html += "<div class='laneWait'>Standard:" +
                    "<div class='dataDisp' style='background-color:" + BwtApp.getColor($sdelay) + ";border-right:5px solid " +
                    BwtApp.getSideColor($sdelay) + ";'><b>" + ($sdelay < 10 ? "< 10 min" : $sdelay + " min") + "</b></div></div>";
            }
        }
        if (portObj.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.operational_status != "N/A") {

            if (portObj.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.operational_status == "Lanes Closed") {
                html += "<div class='laneWait'>" + $laneType + ":<div class='dataDisp' style='color: #cc0033;'><b>Closed</b></div></div>";

            }
            else if (portObj.passenger_vehicle_lanes.NEXUS_SENTRI_lanes.operational_status == "Update Pending") {
                html += "<div class='laneWait'>" + $laneType + ":<div class='dataDisp'><b>Pending</b></div></div>";
            }
            else {
                html += "<div class='laneWait'>" + $laneType + ":" +
                    "<div class='dataDisp' style='background-color:" + BwtApp.getColor($ndelay) + ";border-right:5px solid " + BwtApp.getSideColor($ndelay) + ";'><b>" +
                    ($ndelay < 10 ? "< 10 min" : $ndelay + " min") + "</b></div></div>";
            }
        }

        if (portObj.passenger_vehicle_lanes.ready_lanes.operational_status != "N/A") {

            if (portObj.passenger_vehicle_lanes.ready_lanes.operational_status == "Lanes Closed") {
                html += "<div class='laneWait'>Ready: <div class='dataDisp' style='color: #cc0033;'><b>Closed</b></div></div>";
            }
            else if (portObj.passenger_vehicle_lanes.ready_lanes.operational_status == "Update Pending") {
                html += "<div class='laneWait'>Ready: <div class='dataDisp'><b>Pending</b></div></div>";
            }
            else {
                html += "<div class='laneWait'>Ready: " +
                    "<div class='dataDisp' style='background-color:" + BwtApp.getColor($rdelay) + ";border-right:5px solid " + BwtApp.getSideColor($rdelay) + ";'><b>" +
                    ($rdelay < 10 ? "< 10 min" : $rdelay + " min") + "</b></div></div>";
            }
        }
    }

    ///***********************************   PEDESTRIAN  ***********************************************************/

    if (portObj.pedestrian_lanes.maximum_lanes != "N/A") {

        $sdelay = portObj.pedestrian_lanes.standard_lanes.delay_minutes;
        $rdelay = portObj.pedestrian_lanes.ready_lanes.delay_minutes;
        html += "<div class='typeTitle'>Pedestrian</div>";
        if (portObj.pedestrian_lanes.standard_lanes.operational_status != "N/A") {

            if (portObj.pedestrian_lanes.standard_lanes.operational_status == "Lanes Closed") {
                html += "<div class='laneWait'>Standard: <div class='dataDisp' style='color: #cc0033;'><b>Closed</b></div></div>";
            }
            else if (portObj.pedestrian_lanes.standard_lanes.operational_status == "Update Pending") {
                html += "<div class='laneWait'>Standard: <div class='dataDisp'><b>Pending</b></div></div>";
            }
            else {
                html += "<div class='laneWait'>Standard:" +
                    "<div class='dataDisp' style='background-color:" + BwtApp.getColor($sdelay) + ";border-right:5px solid " + BwtApp.getSideColor($sdelay) + ";'><b>" +
                    ($sdelay < 10 ? "< 10 min" : $sdelay + " min") + "</b></div></div>";
            }
        }
        if (portObj.pedestrian_lanes.ready_lanes.operational_status != "N/A") {

            if (portObj.pedestrian_lanes.ready_lanes.operational_status == "Lanes Closed") {
                html += "<div class='laneWait'>Ready: <div class='dataDisp' style='color: #cc0033;'><b>Closed</b></div></div>";
            }
            else if (portObj.pedestrian_lanes.ready_lanes.operational_status == "Update Pending") {
                html += "<div class='laneWait'>Ready: <div class='dataDisp'><b>Pending</b></div></div>";
            }
            else {
                html += "<div class='laneWait'>Ready: " +
                    "<div class='dataDisp' style='background-color:" + BwtApp.getColor($rdelay) + ";border-right:5px solid " + BwtApp.getSideColor($rdelay) + ";'><b>" +
                    ($rdelay < 10 ? "< 10 min" : $rdelay + " min") + "</b></div></div>";
            }
        }
    }

    return html;
}

function RemoveOldEventHandlers(mapinfo)
{
    if (mapinfo !== null) {
        map.entities.remove(mapinfo);
        if (Microsoft.Maps.Events.hasHandler(mapinfo, 'click'))
        {
            Microsoft.Maps.Events.removeHandler(mapinfo.clickHandler);
        }
        mapinfo = null;
    }
}

//*************************************Route/ Directions************************************

function getDirections() {
        map.getCredentials(callRouteService);
}

function callRouteService(credentials) {
    //&routePathOutput=Points
    var routeRequest = 'http://dev.virtualearth.net/REST/v1/Routes?wp.0=' + start + '&wp.1=' + end + '&routePathOutput=Points&output=json&jsonp=routeCallback&key=' + BingMapsKey;
    
    var mapscript = document.createElement('script');
    mapscript.type = 'text/javascript';
    mapscript.src = routeRequest;    
    document.getElementById('mapDiv').appendChild(mapscript);
}


function routeCallback(result) {

    if (result && result.resourceSets && result.resourceSets.length > 0 && result.resourceSets[0].resources && result.resourceSets[0].resources.length > 0) {
        routeDistance = result.resourceSets[0].resources[0].routeLegs[0].travelDistance + " " + result.resourceSets[0].resources[0].distanceUnit;
        travelTime = result.resourceSets[0].resources[0].routeLegs[0].travelDuration;
        var travelTimeTraffic = result.resourceSets[0].resources[0].routeLegs[0].travelDurationTraffic;
        
        //****************    this writes the route on the map   *********************************
        var bbox = result.resourceSets[0].resources[0].bbox;
        var viewBoundaries = Microsoft.Maps.LocationRect.fromLocations(new Microsoft.Maps.Location(bbox[0], bbox[1]), new Microsoft.Maps.Location(bbox[2], bbox[3]));
        map.setView({ bounds: viewBoundaries });
        var routeline = result.resourceSets[0].resources[0].routePath.line;
        //var routepoints = new Array();
        var routepoints = [];
        for (var i = 0; i < routeline.coordinates.length; i++) {
            routepoints[i] = new Microsoft.Maps.Location(routeline.coordinates[i][0], routeline.coordinates[i][1]);
        }
        var routeshape = new Microsoft.Maps.Polyline(routepoints, { strokeColor: new Microsoft.Maps.Color(200,44,94,235),
                                                     strokeThickness: 5});

        var startPushpinOptions = { anchor: new Microsoft.Maps.Point(10, 32), text: "A", icon: 'Content/images/mappin.png' };
        var startPin = new Microsoft.Maps.Pushpin(new Microsoft.Maps.Location(routeline.coordinates[0][0], routeline.coordinates[0][1]), startPushpinOptions);
        Microsoft.Maps.Events.addHandler(startPin, 'click', ShowCurInfo);
        
        //pb added 11172014
        var endPinText;
        //alert(endLocationPinIndex);
        if(isNaN(endLocationPinIndex)){
            endPinText = "B";
        }
        else{
            endPinText = (parseInt(endLocationPinIndex) + 1).toString();
        }
        
        
        //end pb added
        
        var endPushpinOptions = { anchor: new Microsoft.Maps.Point(10, 32), text: endPinText, icon: 'Content/images/mappin.png' };
        var endPin = new Microsoft.Maps.Pushpin(new Microsoft.Maps.Location(routeline.coordinates[routeline.coordinates.length - 1][0], routeline.coordinates[routeline.coordinates.length - 1][1]), endPushpinOptions);
        Microsoft.Maps.Events.addHandler(endPin, 'click', ShowInfo);
        
        map.entities.clear();//this will remove all other pins that were added before from the map before showing the route.
        
        
            var pushpins = new Microsoft.Maps.EntityCollection();
            var infoboxLayer = new Microsoft.Maps.EntityCollection();
            var routeLayer = new Microsoft.Maps.EntityCollection();
            
            map.entities.push(routeLayer);
            
            map.entities.push(pushpins);
            
            map.entities.push(infoboxLayer);
            
            pushpins.push(startPin);
            pushpins.push(endPin);
            
            mapinfo = new Microsoft.Maps.Infobox(new Microsoft.Maps.Location(0, 0), { visible: false, offset: new Microsoft.Maps.Point(0, 20) });
            
            infoboxLayer.push(mapinfo);
            
            routeLayer.push(routeshape);
        
        //****************   end this writes the route on the map    *********************************
    }
    else {
        if (typeof (result.errorDetails) != 'undefined') {
            //resultsHeader.innerHTML = result.errorDetails[0];
        }
        //alert("No Route found");
    }
}


//************************************   PULL TO REFRESH  starts here   *******************************************************
var PullToRefresh = (function () {
    function Main(container, slidebox, slidebox_icon, handler) {
        var self = this;
        //alert("container: " + container);
        this.breakpoint = 80;

        this.container = container;
        this.slidebox = slidebox;
        this.slidebox_icon = slidebox_icon;       
        this.handler = handler;

        this._slidedown_height = 0;
        this._anim = null;
        this._dragged_down = false;

        this.eventhandler = function (ev) {
            self.handleHammer(ev);
        };
                     
        this.hammertime = Hammer(this.container).off("touch dragdown release")
            .on("touch dragdown release", this.eventhandler);       
        
    }   


    /**
     * Handle HammerJS callback
     * @param ev
     */
    Main.prototype.handleHammer = function (ev) {
        var self = this;

        switch (ev.type) {
            // reset element on start
            case 'touch':
                this.hide();
                break;

                // on release we check how far we dragged
            case 'release':
                if (!this._dragged_down) {
                    return;
                }

                // cancel animation
                cancelAnimationFrame(this._anim);

                // over the breakpoint, trigger the callback
                if (ev.gesture.deltaY >= this.breakpoint) {
                    this.container.className = 'pullrefresh-loading';
                    this.slidebox_icon.className = 'icon loading';

                    this.setHeight(60);
                    this.handler.call(this);
                }
                    // just hide it
                else {
                    
                    this.slidebox.className = 'slideup';
                    this.container.className = 'pullrefresh-slideup';
                    this.hide();
                }
                break;

                // when we dragdown
            case 'dragdown':
                // if we are not at the top move down
                var scrollY = window.scrollY;
                if (scrollY > 5) {
                    return;
                } else if (scrollY !== 0) {
                    window.scrollTo(0, 0);
                }

                this._dragged_down = true;

                // no requestAnimationFrame instance is running, start one
                if (!this._anim) {
                    this.updateHeight();
                }

                // stop browser scrolling
                ev.gesture.preventDefault();

                // update slidedown height
                // it will be updated when requestAnimationFrame is called
                this._slidedown_height = ev.gesture.deltaY * 0.4;
                break;
        }
    };


    /**
     * when we set the height, we just change the container y
     * @param   {Number}    height
     */
    Main.prototype.setHeight = function (height) {       
        this.container.style.top = height + "px";       
    };


    /**
     * hide the pullrefresh message and reset the vars
     */
    Main.prototype.hide = function () {
        this.container.className = '';
        //pb container_el.className = '';
        this._slidedown_height = 0;
        this.setHeight(0);
        cancelAnimationFrame(this._anim);
        this._anim = null;
        this._dragged_down = false;
    };


    /**
     * hide the pullrefresh message and reset the vars
     */
    Main.prototype.slideUp = function () {
        var self = this;
        cancelAnimationFrame(this._anim);

        // pb pullrefresh_el.className = 'slideup';
        this.slidebox.className = 'slideup';
        // pb container_el.className = 'pullrefresh-slideup';
        this.container.className = 'pullrefresh-slideup';

        this.setHeight(0);

        setTimeout(function () {
            self.hide();
        }, 500);
    };


    /**
     * update the height of the slidedown message
     */
    Main.prototype.updateHeight = function () {
        var self = this;

        this.setHeight(this._slidedown_height);

        if (this._slidedown_height >= this.breakpoint) {
            this.slidebox.className = 'breakpoint';
            this.slidebox_icon.className = 'icon arrow arrow-up';
        }
        else {
            this.slidebox.className = '';
            this.slidebox_icon.className = 'icon arrow';
        }

        this._anim = requestAnimationFrame(function () {
            self.updateHeight();
        });
    };
    return Main;
})();




